--declare('LK', {})
--  Used to issue and revoke keys.  From the chat line /keys
	
--	Thanks,
--	Lisa201

-------------------------------------------------------
vokeys = vokeys or {}

vokeys.version = 'K5.44'
vokeys.ui = dofile'ui.lua'
vokeys.SrvHead = {}
vokeys.SrvData = {}
vokeys.KeyTable = {}
LisaJunk = {}

dofile("vars.lua")  -- Variables
dofile("keys_http.lua")  -- This section written by UnCopan Thanks UnCopan!!
dofile("ui.lua") -- User interface 
dofile("ui2.lua") -- User interface 
dofile("systems.lua") -- Load faction and system names table.
dofile("json.lua")

-------------------------------------------------------
-- Process server data received event
-------------------------------------------------------
function vokeys.ServerDataEvent(_,data)
local v = data[1][1]
if vokeys.debug then print("Server data is back from: "..v) end
    if     v == "listuserkeys" then vokeys.Users = data[2]; vokeys.Users_loaded = true;LisaJunk = data[2]
    elseif v == "listownerkeys" then vokeys.Owners = data[2]; vokeys.Owners_loaded = true
    elseif v == "listnokeys" then vokeys.NoKeys = data[2]; vokeys.NoKeys_loaded = true
    elseif v == "h" then print("aychuei!")
	end
end

-------------------------------------------------------
-- CallBack from server requests.
-------------------------------------------------------
function vokeys.GetServerData(script)
if vokeys.debug then print("Requesting data from Server:"..script) end
urlopen('http://www.tgft.org/vendetta/'..script..'.php', 'POST',
	function (not_ok, header, data)
		if not_ok then
			vokeys.msg(vokeys.colors.WHITE,not_ok)
		else
			data = string.gsub(data, "^\r", "")
			data = string.gsub(data, "^\n", "")
			if (header.status == 200) then --Process what came back
				if (string.len(data) < 1) then return end
				vokeys.SrvHead = json.decode(data)
				ProcessEvent("SERVER_DATA_RECEIVED", vokeys.SrvHead)
			elseif header.status then
				vokeys.msg(vokeys.colors.WHITE,"ERROR7: HTTP Error "..header.status.."  Script:"..script)
			end
		end
	end
	,{username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version})
end

-------------------------------------------------------
-- Server Call back function 
-------------------------------------------------------
function vokeys.Server_New_CB(not_ok, header, server_results)
if vokeys.debug then print("Keys Server New Callback Function...") end
local tgft_utils_srvdata	= {}
  if not_ok then
  	print("\127ffffffERROR31: "..not_ok)
  else
    if header.status == 200 then --Process what came back
  		for token in string.gmatch(server_results, "[^\n]+") do --Convert to table
  			if token ~= "\r" then 
				table.insert(tgft_utils_srvdata,token) 
				print("\127ffffff"..token)
			end
		end   
  	else
		if header.status then
    		vokeys.msg(tgft_utils_White,"ERROR33: HTTP Error "..header.status)
		end
  	end --Process what came back
   end
end

-------------------------------------------------------
-- Msg the user 
-------------------------------------------------------
function vokeys.msg(c,msg)
	if (msg) then print(c .. msg) end
end

-------------------------------------------------------
-- Toggle debug the user 
-------------------------------------------------------
function vokeys.debugtoggle()
	if vokeys.debug then 
		vokeys.debug = false
		vokeys.msg(vokeys.colors.WHITE,"Debug is now OFF")
	else
		vokeys.debug = true
		vokeys.msg(vokeys.colors.WHITE,"Debug is now ON")
	end
end

-------------------------------------------------------
-- key call-back function
-------------------------------------------------------
function vokeys.IssuingKeysCB(err,result)
if err then 
	if not (result == "That player already has that key.") then
		vokeys.msg(vokeys.colors.WHITE,"Result: "..result)
		end
	end
end

-------------------------------------------------------
-- Find the lowest key number in your chain
-------------------------------------------------------
function vokeys.LowKey()
local minkey = 10000
local idx = 0 
	for i = 1, #vokeys.KeyTable, 1 do 
	if tonumber(vokeys.KeyTable[i].ID) < minkey then
		minkey = tonumber(vokeys.KeyTable[i].ID)
		idx = i
		end
	end
	return idx, minkey
end

-------------------------------------------------------
-- Sort the keys table now that they come in randomly
-------------------------------------------------------
function vokeys.SortKeys()
if vokeys.debug then print("Sorting the key list") end
local newkeys = {}
	while (#vokeys.KeyTable > 0) do
	local index, minkey = vokeys.LowKey()
	table.insert(newkeys,vokeys.KeyTable[index])
	table.remove(vokeys.KeyTable,index)
	end
	vokeys.KeyTable = newkeys
end

-------------------------------------------------------
-- Get a keys slot number; Slot in your keychain
-------------------------------------------------------
function vokeys.GetKeySlot(keynum)
	for i = 1, GetNumKeysInKeychain(), 1 do 
		LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(i)
		if (tonumber(LK_keyid) == tonumber(keynum)) then return i end
	end
return -1 -- Not found in the list 
end

-------------------------------------------------------
-- Get key data as you get the key event
-------------------------------------------------------
function vokeys.NewKeyReceived(event,data)
if vokeys.debug then print("New Key Event... :"..event.."  Data:"..data) end
local keyslot = vokeys.GetKeySlot(data)
Keychain.list(data, 
	function(isError, message)
		if (isError) then
			print("KEY ERROR MESSAGE:"..message)
		else
			local keyid, description, owner, timestamp, access, possessors, active = GetKeyInfo(vokeys.GetKeySlot(data))
			local key_data = {ID = keyid, DESC = description, OWN = owner, TIME = timestamp, ACCESS = access,  POSS = possessors, ACTIVE = active}
			table.insert(vokeys.KeyTable,key_data)

			if not owner and vokeys.IsCapshipKey(key_data) then
				if vokeys.debug then print("It's a owner key to a capship!!  "..data) end
				vokeys.Add_NoKey(data)
			end	
		end
	end)
end

-------------------------------------------------------
-- Rescan your keychain after something changes.
-------------------------------------------------------
function vokeys.RescanKeys()
RegisterEvent(vokeys.RevokedKey, "KEYREMOVED") -- Start listening again.
vokeys.KeyTable = {}	-- Empty the key list first.
	for i = 1, GetNumKeysInKeychain(), 1 do
	local keyid, description, owner, timestamp, access, possessors, active = GetKeyInfo(i)
	ProcessEvent("SCAN_KEYCHAIN",keyid)
	if vokeys.debug then print("KeyID:"..keyid) end
	end
end

-------------------------------------------------------
-- Key was removed, so rescan the key list and update 
-------------------------------------------------------
function vokeys.RevokedKey()
UnregisterEvent(vokeys.RevokedKey, "KEYREMOVED") -- Stop listening for a bit...
if vokeys.debug then print("Lost Key Event ") end
vokeys.Timer:SetTimeout(4000,vokeys.RescanKeys)
end

-------------------------------------------------------
-- List Keys 
-------------------------------------------------------
function vokeys.IsCapshipKey(x)
return (	x.ACCESS[1] and x.ACCESS[1][1].name and not (
	x.ACCESS[1][1].name == "Pelatus Mining Station" or
	x.ACCESS[1][1].name == "Bractus IX Planetary Outpost" or
	x.ACCESS[1][1].name == "CONQUERABLE STATION"))
end

-------------------------------------------------------
-- List Keys 
-------------------------------------------------------
function vokeys.Show_Keys(x)
	local myoutput = ""
	local line = ""
	local color = vokeys.colors.RED -- Default color for in-active keys.
	for i = 1, #vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		line = i..": "..LK_key_data.ID .. " <" .. LK_key_data.DESC  .. ">  " 
		line = LK_key_data.ID .. " <" .. LK_key_data.DESC  .. ">  " 
		color = vokeys.colors.RED -- Default color for in-active keys.
		if LK_key_data.ACTIVE then 
			line = line .. "ACTIVE "
			color = vokeys.colors.GREY2  
			end
		if not LK_key_data.OWN then 
			line = line .. "OWNER KEY " 
			if LK_key_data.ACTIVE then color = vokeys.colors.WHITE end
				if not vokeys.IHaveUserKey(LK_key_data.ID) then
					if vokeys.debug then print("Need to create a user key for this owner!  "..LK_key_data.ID) end
					-- Give myself a user key!!!
					Keychain.giveuserkey(vokeys.username, LK_key_data.ID, vokeys.IssuingKeysCB)
				end
			end
			--LisaJunk = LK_key_data
		if vokeys.IsCapshipKey(LK_key_data) then 
				line = line .. vokeys.colors.YELLOW.." - "..LK_key_data.ACCESS[1][1].name
		end
		if (x == 0) then -- Show ALL the keys
			myoutput = myoutput..color..line.."\n"
		elseif (x == 1) and ((LK_key_data.ACTIVE) and (LK_key_data.OWN))  then -- Just the user keys please
			myoutput = myoutput..color..line.."\n"
		elseif (x == 2) and ((LK_key_data.ACTIVE) and (not LK_key_data.OWN))  then -- Just the owner keys please
			myoutput = myoutput..color..line.."\n"
		end
	end
	vokeys.ui:ShowOutput(myoutput)
end

-------------------------------------------------------
-- Do I have Key 
-------------------------------------------------------
function vokeys.IHaveKey(x)
	x = tostring(x)
	for i = 1, #vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		if (LK_key_data.ID and LK_key_data.ID == x) then return true end
	end
return false
end

-------------------------------------------------------
-- Do I have user Key for this owner key?
-------------------------------------------------------
function vokeys.IHaveUserKey(ownerkey)
	ownerkey = tostring(ownerkey)
	for i = 1, #vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		if (LK_key_data and LK_key_data.OWN and (LK_key_data.OWN == ownerkey)) then return true end
	end
return false
end

-------------------------------------------------------
-- Do I have this key?
-------------------------------------------------------
function vokeys.IHaveKey(thekey)
	thekey = tostring(thekey)
	for i = 1, #vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		if (LK_key_data and LK_key_data.ID == thekey) then return true end
	end
return false
end

-------------------------------------------------------
-- Purge Old User Keys 
-------------------------------------------------------
function vokeys.Purge()
	for i = 1, #vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		local color = vokeys.colors.RED -- Default color for in-active keys.
		local line = LK_key_data.ID .. " <" .. LK_key_data.DESC  .. ">  " 
		if (not LK_key_data.ACTIVE) and (LK_key_data.OWN) and not vokeys.IHaveKey(LK_key_data.OWN) then 
			-- Just the user keys please
			vokeys.Deletekey(LK_key_data.ID)
		end
	end
end

-------------------------------------------------------
-- Clean ALL old user keys from EVERYONE 
-------------------------------------------------------
function vokeys.CleanKeys()
	vokeys.msg(tgft_utils_White,"Cleaning out old keys for everyone!")
	for i = 1, #vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		if (not LK_key_data.ACTIVE) and (LK_key_data.OWN) then 
			-- Just the user keys please
			--vokeys.Deletekey(LK_key_data.ID)
			print("test message revokeall key "..LK_key_data.ID)
		end
	end
end

-------------------------------------------------------
-- Show Keys status for conq stations
-------------------------------------------------------
function vokeys.Key_Status()
	--vokeys.RescanKeys()
	local valid_keys = 0
	vokeys.msg(vokeys.colors.GREY2,"Curret Key Status:")
	for i = 1, #vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		if LK_key_data.ACTIVE then
			if vokeys.debug then print("ks Active key") end
			vokeys.Key = LK_key_data.ID
			local i = vokeys.GetKeySlot(vokeys.Key)
			LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(i))
			if not LK_access then break end
			for j = 1, # LK_access, 1 do 
				local GoodKey = true
				local msg = vokeys.Key.."   "..LK_access[j][1].name.." - "..LK_description.." - "
				if LK_access[j][2].candock then
					msg = msg .. vokeys.colors.GREEN 
				else 
					msg = msg .. vokeys.colors.RED 
					GoodKey = false
				end
				msg = msg .."Dock - "
				
				if LK_access[j][2].iff then 
					msg = msg .. vokeys.colors.GREEN 
				else 
					msg = msg .. vokeys.colors.RED 
					GoodKey = false
				end
				msg = msg .."IFF"
				if vokeys.IHaveKey(tostring(LK_key_data.OWN)) then
					msg = msg .. vokeys.colors.GREEN .." - Owner"
				end

				if vokeys.debug then print("ks 4: ".. (LK_owner or "Empty")) end
				if LK_owner and not string.find(LK_access[j][1].name, "Capship") then
					valid_keys = valid_keys +1
					if GoodKey then vokeys.msg(vokeys.colors.GREEN,msg)
					if vokeys.debug then print("ks Good Key") end
				else
					if vokeys.debug then print("ks BAD Key") end
					vokeys.msg(vokeys.colors.YELLOW,msg)
					end
				end
			end
		end 
	end
vokeys.msg(vokeys.colors.GREEN,"Valid key count is: "..valid_keys)
end 

-------------------------------------------------------
-- Person in Our user list?
-------------------------------------------------------
function vokeys.InUserList(towho)
	for k,j in pairs(vokeys.Users) do
		if (j == towho) then return true end
	end
	return false;
end

-------------------------------------------------------
-- Person in Our Owner list?
-------------------------------------------------------
function vokeys.InOwnerList(towho)
	for k,j in pairs(vokeys.Owners) do 
		if (j == towho) then return true end
	end
	return false;
end

-------------------------------------------------------
-- Key in Capship key list?
-------------------------------------------------------
function vokeys.InNoKeyList(keynum)
	for k,j in pairs(vokeys.NoKeys) do 
		if (tonumber(j) == tonumber(keynum)) then 
			if vokeys.debug then print("Found in the no key list.  "..keynum) end
			return true 
		end
	end
	return false;
end

-------------------------------------------------------
-- Give User keys
-------------------------------------------------------
function vokeys.Give_User_Key(towho,addtolist)
	local found = 0
	for i = 1, # vokeys.KeyTable, 1 do -- Go through all our keys
		local LK_key_data = vokeys.KeyTable[i]
		if LK_key_data.ACTIVE and vokeys.IHaveKey(LK_key_data.OWN) then -- for any owner keys I have, issue them.
			if vokeys.debug then print("UKEY:"..LK_key_data.ID.." To:"..towho) end
				--local x = tonumber(LK_key_data.ID)
				Keychain.giveuserkey(towho, LK_key_data.ID, vokeys.IssuingKeysCB)
				if addtolist and not vokeys.InUserList(towho) then -- User is new.  Put them in the list.
					vokeys.msg(vokeys.colors.WHITE,"New User added to Key List: "..towho)
					table.insert(vokeys.Users,towho) -- Add the user to the saved user list.
					urlopen('http://www.tgft.org/vendetta/adduserkey.php', 'POST',vokeys.Server_New_CB, {username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version, data=towho})
					if vokeys.debug then print("Added user to keys list on server: "..towho) end
					vokeys.GetServerData("listuserkeys")
				end
		end
	end
end

-------------------------------------------------------
-- Give Owner keys
-------------------------------------------------------
function vokeys.Give_Owner_Key(towho)
local found = 0
	for i = 1, #vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		if (LK_key_data.ACTIVE and not LK_key_data.OWN and not vokeys.InNoKeyList(LK_key_data.ID)) then 
				if vokeys.debug then print("NOT Restricted Owner key:"..LK_key_data.ID) end
				Keychain.giveownerkey(towho, LK_key_data.ID, vokeys.IssuingKeysCB) --Issue the owner key
				if vokeys.debug then print("Issuing owner key "..LK_key_data.ID.." to : "..towho) end
				if  not vokeys.InOwnerList(towho) then -- User is new.  Put them in the list.
					if vokeys.debug then vokeys.msg(vokeys.colors.WHITE,"New owner added to saved list: "..towho) end
					table.insert(vokeys.Owners,towho) -- Add the user to the saved user list.
					urlopen('http://www.tgft.org/vendetta/addownerkey.php', 'POST',vokeys.Server_New_CB, {username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version, data=towho})
					vokeys.GetServerData("listownerkeys")
				end
			end
	end
end

-------------------------------------------------------
-- Add a key to the restricted list
-------------------------------------------------------
function vokeys.Add_NoKey(num)
if vokeys.debug then print("Adding this capship key to the nokeys list.") end
num = string.lower(num)
urlopen('http://www.tgft.org/vendetta/addcapshipkey.php', 'POST',vokeys.Server_New_CB, {username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version, data=num})
vokeys.GetServerData("listnokeys")
end

-------------------------------------------------------
-- Remove User from the list
-------------------------------------------------------
function vokeys.Remove(towho)
	for k,j in pairs(vokeys.Users) do -- see if the user is in the list.
		if (j == towho) then 
			vokeys.msg(vokeys.colors.WHITE,"Removing "..towho.." From the Users list")
			urlopen('http://www.tgft.org/vendetta/remuserkey.php', 'POST',vokeys.Server_New_CB, {username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version, data=towho})
			table.remove(vokeys.Users,k); 
		end
	end		
	for k,j in pairs(vokeys.Owners) do -- see if the owners is in the list.
		if (j == towho) then 
			vokeys.msg(vokeys.colors.WHITE,"Removing "..towho.." From the Owners list")
			urlopen('http://www.tgft.org/vendetta/remownerkey.php', 'POST',vokeys.Server_New_CB, {username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version, data=towho})
			table.remove(vokeys.Owners,k); 
		end
	end
end

-------------------------------------------------------
-- Revoke keys 
-------------------------------------------------------
function vokeys.Revoke(towho)
for i = 1, # vokeys.KeyTable, 1 do 
	local LK_key_data = vokeys.KeyTable[i]
	if LK_key_data.ACTIVE and not LK_key_data.OWN then 
		vokeys.msg(vokeys.colors.WHITE,"Revoking keys " ..  LK_key_data.ID .. " from " .. towho)
		Keychain.revokekey(towho, LK_key_data.ID, vokeys.IssuingKeysCB)
	end
end
for k,j in pairs(vokeys.Users) do -- see if the user is in the list.
	if (j == towho) then table.remove(vokeys.Users,k); break; end
end		
for k,j in pairs(vokeys.Owners) do -- see if the owners is in the list.
	if (j == towho) then table.remove(vokeys.Owners,k); break; end
end		
urlopen('http://www.tgft.org/vendetta/remuserkey.php', 'POST',vokeys.Server_New_CB, {username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version, data=towho})
urlopen('http://www.tgft.org/vendetta/remownerkey.php', 'POST',vokeys.Server_New_CB, {username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version, data=towho})
end

-------------------------------------------------------
-- Guild
-------------------------------------------------------
function vokeys.Guild()
vokeys.msg(vokeys.colors.WHITE,"Issuing valid keys to all logged-on guild members...") 
for i=1,GetNumGuildMembers() do
  local id, rank, name = GetGuildMemberInfo(i)
	vokeys.Give_User_Key(name,true)
	urlopen('http://www.tgft.org/vendetta/guildaccess.php', 'POST',vokeys.Server_New_CB, {username=vokeys.username, passwd=vokeys.passwd, app=vokeys.version, data=name})
	end
vokeys.GetServerData("listuserkeys") --Reload the keys list
end

-------------------------------------------------------
-- Saved List
-------------------------------------------------------
function vokeys.Saved()
vokeys.msg(vokeys.colors.WHITE,"Keying those in user stored list...")
	for k,j in pairs(vokeys.Users) do -- Go through the list.
		vokeys.Give_User_Key(j,false)
	end
	vokeys.msg(vokeys.colors.GREY2,"Keying those in Owner stored list...")
	for k,j in pairs(vokeys.Owners) do -- Go through the list.
		vokeys.Give_Owner_Key(j)
	end
end

-------------------------------------------------------
-- Show Saved List
-------------------------------------------------------
function vokeys.Show_Saved()
	local cols = 4
	local myoutput = vokeys.colors.WHITE.."User Keys to: \n"..vokeys.colors.GREY2
	for k,j in pairs(vokeys.Users) do
		myoutput = myoutput..j.."\n"
	end
	myoutput = myoutput..vokeys.colors.WHITE.."\nOwner Keys to: \n"..vokeys.colors.GREY2
	for k,j in pairs(vokeys.Owners) do
		myoutput = myoutput..j.."\n"
	end
	vokeys.ui:ShowOutput(myoutput)
end

-------------------------------------------------------
-- Show Saved List 
-------------------------------------------------------
function vokeys.Show_Saved2()
	vokeys.ui:ShowOutput(myoutput)
end

-------------------------------------------------------
-- Give User keys for capship
-------------------------------------------------------
function vokeys.Capship(towho)
	vokeys.msg(vokeys.colors.WHITE,"Giving your caphip keys to: "..towho)
	for k,j in pairs(vokeys.NoKeys) do
		if vokeys.IHaveKey(j) then 
			vokeys.msg(vokeys.colors.GREY2,"I own key "..j.." so issuing it...")
			Keychain.giveuserkey(towho, j, vokeys.IssuingKeysCB)
		end
	end
end

-------------------------------------------------------
-- Revoke User keys for capship
-------------------------------------------------------
function vokeys.Capship_Revoke(towho)
	vokeys.msg(vokeys.colors.WHITE,"Revoking your caphip keys from: "..towho)
	for k,j in pairs(vokeys.NoKeys) do
		if vokeys.IHaveKey(j) then 
			vokeys.msg(vokeys.colors.GREY2,"I own key "..j.." so revoking it...")
			Keychain.revokekey(towho, j, vokeys.IssuingKeysCB)
		end
	end
end

-------------------------------------------------------
-- Delete a key(s)
-------------------------------------------------------
function vokeys.Deletekey(keynum)
	for i = 1, # vokeys.KeyTable, 1 do 
		local LK_key_data = vokeys.KeyTable[i]
		if keynum == LK_key_data.ID then
			vokeys.msg(vokeys.colors.WHITE,"Deleting key " ..  LK_key_data.ID .. " Named: " .. LK_key_data.DESC)
			Keychain.deletekey(LK_key_data.ID, LK_key_data.DESC, vokeys.IssuingKeysCB)
			break;
		end
	end
	vokeys.Keys_loaded = false
end

-------------------------------------------------------
-- Revoke all users from a key
-------------------------------------------------------
function vokeys.RevokeAll(err,result)
	if (vokeys.GetKeySlot(vokeys.Key)<0) then
		vokeys.msg(vokeys.colors.WHITE,"No such key.")
		return
	else
		print("Revoking all users from key: "..vokeys.Key)
		local i = vokeys.GetKeySlot(vokeys.Key)
		LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(vokeys.GetKeySlot(vokeys.Key)))
		if not vokeys.IHaveKey(LK_owner) then
  		vokeys.msg(vokeys.colors.WHITE,"You do not have the owner key.")
  		return end
		for j = 0, #LK_possessors, 1 do 
			local player = GetPlayerName(LK_possessors[j])
			vokeys.msg(vokeys.colors.WHITE,player.." Revoked...")
			Keychain.revokekey(player, vokeys.Key, vokeys.IssuingKeysCB)
		end
	end
end

-------------------------------------------------------
-- list Key Users
-------------------------------------------------------
function vokeys.ListKeyUsers(err,result)
	LK_keyid, LK_description, LK_owner, LK_timestamp, LK_access, LK_possessors, LK_active = GetKeyInfo(tonumber(vokeys.GetKeySlot(vokeys.Key)))
	local myoutput = vokeys.colors.WHITE.."Players with this key:\n"..vokeys.colors.GREY2
	for j = 1, # LK_possessors, 1 do 
		local player = GetPlayerName(LK_possessors[j])
		table.insert(vokeys.data,player)
	end
	table.sort(vokeys.data)
	local i = 1
	local cols = 4
	for j = 1, # vokeys.data, 1 do 
		myoutput = myoutput..vokeys.data[j].."\n"
	end
	vokeys.ui:ShowOutput(myoutput)
end

-------------------------------------------------------
-- Get key data for other functions
-------------------------------------------------------
function vokeys.KeyData(keynum,cbname)
	if (vokeys.GetKeySlot(keynum)<0) then
  	vokeys.msg(vokeys.colors.WHITE,"No such key in your keychain.")
  	return false
	else
		vokeys.Key = keynum
		vokeys.data = {}
		Keychain.list(keynum, cbname)
	end
return true
end

-------------------------------------------------------
-- ReloadInterface
-------------------------------------------------------
function vokeys.Reload()
	vokeys.msg(vokeys.colors.WHITE,"Reloading interface....")
	ReloadInterface()
end

-------------------------------------------------------
-- create random string for password
-------------------------------------------------------
function vokeys.RandomString(length)
if length < 1 then return nil end
local valChars = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
length = length or 1
local array = ""
for i = 1,length do
	local A = math.random(#valChars)
	array = array..string.sub(valChars,A,A)
end
return array
end

-------------------------------------------------------
-- Init KEYS and
-------------------------------------------------------
function vokeys.Init()
	vokeys.debug = false
	UnregisterEvent(vokeys.Init, "UPDATE_CHARINFO")
	if vokeys.debug then print("Doing first init") end
	vokeys.username = GetPlayerName(GetCharacterID())
	vokeys.passwd = gkini.ReadString("TGFT_Util","Password" ,"None")
	if ((vokeys.passwd == "None") or (string.len(vokeys.passwd) < 20)) then 
		vokeys.passwd = tgft_utils.RandomString(30)
		gkini.WriteString("TGFT_Util", "Password", vokeys.passwd)
		if vokeys.debug then print("Your Password is:"..vokeys.passwd) end
	end
	if vokeys.debug then print("Username: "..vokeys.username.."  Password: "..vokeys.passwd) end
	vokeys.Timer:SetTimeout(7000,vokeys.Init1)
end

-------------------------------------------------------
-- Init KEYS and 
-------------------------------------------------------
function vokeys.Init1()
	vokeys.GetServerData("listnokeys")
	vokeys.GetServerData("listuserkeys")
	vokeys.GetServerData("listownerkeys")
	vokeys.Timer:SetTimeout(12000,vokeys.Init2)
end

-------------------------------------------------------
-- Init KEYS and 
-------------------------------------------------------
function vokeys.Init2()
	--vokeys.SortKeys()
	vokeys.RescanKeys()
	vokeys.msg(vokeys.colors.WHITE,"Keys Version: ".. vokeys.version)
end

-------------------------------------------------------
-- ReInit KEYS 
-------------------------------------------------------
function vokeys.ReInit()
	UnregisterEvent(vokeys.Init, "UPDATE_CHARINFO")
	if vokeys.debug then print("Doing first init") end
	vokeys.username = GetPlayerName(GetCharacterID())
	vokeys.passwd = gkini.ReadString("TGFT_Util","Password" ,"None")
	if ((vokeys.passwd == "None") or (string.len(vokeys.passwd) < 20)) then 
		vokeys.passwd = tgft_utils.RandomString(30)
		gkini.WriteString("TGFT_Util", "Password", vokeys.passwd)
		if vokeys.debug then print("Your Password is:"..vokeys.passwd) end
	end
	if vokeys.debug then print("Username: "..vokeys.username.."  Password: "..vokeys.passwd) end
	vokeys.GetServerData("listnokeys")
	vokeys.GetServerData("listuserkeys")
	vokeys.GetServerData("listownerkeys")
	vokeys.RescanKeys()
	vokeys.msg(vokeys.colors.WHITE,"Keys Version: ".. vokeys.version)
end
-------------------------------------------------------
-- Test display .---------Stuff I'm Playing with
-------------------------------------------------------
function vokeys.Test()
--vokeys.RescanKeys()
--if vokeys.IHaveKey(1394) then print("got the key!") else print("don't have that key") end
--vokeys.ui.dlg:show()
vokeys.ui.create_dialog()
end

-------------------------------------------------------
-- Main
-------------------------------------------------------
function vokeys.Commands(_,data) -- Process the commands that were given.
	if not data then
		vokeys.ui:ShowHelp(); return
	else
		local command = string.lower(data[1])

		if (command == "-list") then	vokeys.Show_Keys(0)
		elseif (command == "-ver") or (command == "-version") then 
			vokeys.msg(vokeys.colors.WHITE,"Keys Version: " .. vokeys.version)
		elseif (command == "-info") then vokeys.Info()
		elseif (command == "-addown") then vokeys.Give_Owner_Key(data[2]) ; vokeys.GetServerData("listownerkeys")
		elseif (command == "-cleankeys") then vokeys.CleanKeys()
		elseif (command == "-listown") then vokeys.Show_Keys(2)
		elseif (command == "-own") then vokeys.Show_Keys(2)
		elseif (command == "-saved") then vokeys.Saved()
		elseif (command == "-debug") then vokeys.debugtoggle()
		elseif (command == "-purge") then vokeys.Purge()
		elseif (command == "-show") then vokeys.Show_Saved()
		elseif (command == "-show2") then vokeys.Show_Saved2()
		elseif (command == "-listuser") then vokeys.Show_Keys(1)
		elseif (command == "-user") then vokeys.Show_Keys(1)
		elseif (command == "-listkey") then vokeys.KeyData(data[2],vokeys.ListKeyUsers)
		elseif (command == "-guild") then vokeys.Guild()
		elseif (command == "-revoke") then vokeys.Revoke(data[2])
		elseif (command == "-revokeall") then vokeys.KeyData(data[2],vokeys.RevokeAll)
		elseif (command == "-remove") then vokeys.Remove(data[2])
		elseif (command == "-status") then vokeys.Key_Status()
		elseif (command == "-test") then vokeys.Test()
		elseif (command == "-init") then vokeys.ReInit()
		elseif (command == "-capship") then vokeys.Give_User_Key(data[2],false)
		elseif (command == "-caprevoke") then
			if vokeys.capship then
			vokeys.Capship_Revoke(data[2]); return end
		elseif (command == "-delete") then
			local i = 2
			while data[i] ~= nil  do
				vokeys.Deletekey(data[i]) -- Process all command line user names
				i = i+1
			end
			
		elseif (command == "-help") then
			vokeys.ui:ShowHelp(); return
			elseif (command == "-add") or (command == "-adduser")then
			local i = 2
			while data[i] ~= nil  do
				vokeys.Give_User_Key(data[i],true)
				i = i+1
			end
		else
			vokeys.ui:ShowHelp()
		end
	end
end

----------------------------------------------------------------------
-- Commands the user can use
RegisterUserCommand("keys",vokeys.Commands);
RegisterUserCommand("keystat",vokeys.Key_Status);
RegisterUserCommand("ks",vokeys.Key_Status);
RegisterUserCommand("keyui",vokeys.ui.create_dialog);


RegisterEvent(vokeys.Init, "UPDATE_CHARINFO")
RegisterEvent(vokeys.ServerDataEvent, "SERVER_DATA_RECEIVED")
RegisterEvent(vokeys.NewKeyReceived, "SCAN_KEYCHAIN") -- Get the additional keydata for each key.
RegisterEvent(vokeys.NewKeyReceived, "KEYADDED") -- Get the additional keydata for each key.
RegisterEvent(vokeys.RevokedKey, "KEYREMOVED") -- Lost a key.
