vokeys.settings = vokeys.settings or {}
vokeys.settings.showinactive = vokeys.settings.showinactive or 0

function vokeys.ui.close_dialog()
	vokeys.ui.dlg:hide()
end

function vokeys.ui.create_dialog()
	--local color

	-- station keys tab
	local key_table = iup.matrix {numcol=5, numlin=#vokeys.KeyTable, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	key_table:setcell(0,1,"KeyID")
	key_table:setcell(0,2,"Name")
	key_table:setcell(0,3,"Access To")
	key_table:setcell(0,4,"Capship")
	vokeys.ui.fill_key_matrix(key_table)
	local keychain_tab = iup.hbox {key_table, iup.fill{}}
	keychain_tab.tabtitle = "Keys in Chain"

	-- Users key tab
	local users_table = iup.matrix {numcol=1, numlin=#vokeys.Users, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	users_table:setcell(0,1,"Player Name")
	vokeys.ui.fill_user_key_matrix(users_table)
	local users_tab = iup.vbox {users_table, iup.fill{size=10}}
	users_tab.tabtitle = "User Keys List"

	-- Owner key tab
	local owners_table = iup.matrix {numcol=1, numlin=#vokeys.Owners, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
	owners_table:setcell(0,1,"Player Name")
	vokeys.ui.fill_owner_key_matrix(owners_table)
	local owners_tab = iup.vbox {owners_table, iup.fill{size=10}}
	owners_tab.tabtitle = "Owner Keys List"

	-- bottom close button
	local close_button = iup.button{title="Close", size=100}
	function close_button:action ()
		vokeys.ui.close_dialog()
	end

	local saved_button = iup.button{title="Saved", size=100}
	function saved_button:action ()
		vokeys.Saved()
	end
	
	local guild_button = iup.button{title="Guild", size=100}
	function guild_button:action ()
		vokeys.Guild()
	end
	
	local active_keys_items = iup.stationtoggle{ value=vokeys.settings.showinactive or 0, title="Show Inactive"}
	
	function active_keys_items.action(_, state) 
		vokeys.settings.showinactive = state 
		print("Show Inactive is "..vokeys.settings.showinactive)
		--key_table = iup.matrix {numcol=5, numlin=#vokeys.KeyTable, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
		--vokeys.ui.fill_key_matrix(key_table)
		--vokeys.ui.dlg:redraw()
		--vokeys.ui.fill_key_matrix(key_table)
		--vokeys.ui.dlg:hide()
		--key_table = iup.matrix {numcol=5, numlin=#vokeys.KeyTable, markmode="LIN", expand="YES", bgcolor="0 0 0 80 *"}
		vokeys.ui.fill_key_matrix(key_table)
		--vokeys.ui.dlg:show()
		--vokeys.ui.dlg:Refresh()
		--iup.pda_root_tabs:redraw()
	end 

	


	
	local bottom_button_box = iup.hbox {iup.fill{}, active_keys_items, guild_button, saved_button, close_button, gap=5}

	-- dialog
	
	local tabs = iup.pda_root_tabs{keychain_tab, users_tab, owners_tab }
	
	local dialog_vbox = iup.vbox {
		tabs,
		iup.fill{size="%2"},
		bottom_button_box,
		expand="YES",
	}
	
	vokeys.ui.dlg = iup.dialog{
    iup.vbox{
			iup.fill{size="%10"},
        iup.hbox{
					iup.fill{size="%15"},
					iup.pdarootframe{
						dialog_vbox
					},
					iup.fill{size="%15"},
       },
        iup.fill{size="%10"},
			},
		defaultesc=vokeys.ui.close_dialog,		
    bgcolor="0 0 0 144 *",
    fullscreen="YES",
    border="NO",
    resize="NO",
    maxbox="NO",
    minbox="NO",
    menubox="NO",
    topmost="YES",
	}
	vokeys.ui.dlg:show()

end

-- Build the matrix for our key list.  
function vokeys.ui.fill_key_matrix(table)
	--table.resizematrix = "YES"
	local row = 1
	local color
	for i = 1, #vokeys.KeyTable, 1 do 		
		color = vokeys.colors.WHITE
		if (vokeys.KeyTable[i].ACTIVE or vokeys.settings.showinactive == 1) then 



			if not vokeys.KeyTable[i].OWN and vokeys.KeyTable[i].ACTIVE	then 
				color = vokeys.colors.GOLD
			elseif not vokeys.KeyTable[i].ACTIVE then
				color = vokeys.colors.RED
			end
			table:setcell(row, 1, color..vokeys.KeyTable[i].ID)
			table:setcell(row, 2, color..vokeys.KeyTable[i].DESC)
			local temp = ""
			if not (vokeys.IsCapshipKey(vokeys.KeyTable[i])) and (vokeys.KeyTable[i].ACCESS[1]) then
				for j = 1, #vokeys.KeyTable[i].ACCESS,1 do
				temp = temp..vokeys.KeyTable[i].ACCESS[j][1].name.."  "
				end
			end
			table:setcell(row, 3, color..temp)
			table:setcell(row,4,"")
			if vokeys.IsCapshipKey(vokeys.KeyTable[i]) then 
				table:setcell(row,4,vokeys.colors.YELLOW..vokeys.KeyTable[i].ACCESS[1][1].name)
			end
		row = row + 1
		end
		
		
		
		
	end
end

-- Build the matrix for our user key list.  
function vokeys.ui.fill_user_key_matrix(table)
	local row = 1
	local color
	for i = 1, #vokeys.Users, 1 do 		
		color = vokeys.colors.WHITE
		table:setcell(row, 1, color..vokeys.Users[i])
		row = row + 1
	end
end

-- Build the matrix for our Owner key list.  
function vokeys.ui.fill_owner_key_matrix(table)
	local row = 1
	local color
	for i = 1, #vokeys.Owners, 1 do 		
		color = vokeys.colors.WHITE
		table:setcell(row, 1, color..vokeys.Owners[i])
		row = row + 1
	end
end
